angular.module('starter.directive', [])


.factory('loadMore',['getHttp', '$q', 'defConfig', function (getHttp, $q, defConfig) {
  
  
  return function ($scope,item,pm, cb)  {
//    var items = {};
//      $scope[item]  = items;
//      items.datas = [];
    
    $scope[item] = {
        datas:[]
    };
    
    var i = 0,
      page = 1,
      totalPage = 0;
    
    function addDatas () {
      var par = {};
      
      //初始化加载数量
      var pageDefSize = 20;
      
      if (page == 1) {
    	  pageDefSize = 50;
      }
      
      if (pm.path == '/auth/questionList') {
        par = {
            quesState: pm.state || 0,
            page: page++,
            pageSize: pm.pageSize || 20 
        };
      }else {
        par = {
            sortType: pm.sortType || '',
            state: pm.state || 0,
            //type: pm.state || 0,
            page: page++,
            pageSize: pm.pageSize || 20 
        };
        par = angular.extend(par, pm);
      }
      getHttp({
          method: pm.method || 'post',
          path: defConfig.path + pm.path,
          params: par,
          loading: true
        })
        .then(function (data) {
          if(data.result) {
            $scope.draftCount = data.result.count;
            if (data.result.totalPage === 1) {
              $scope.onlyOnePage = true;
            }else {
              $scope.onlyOnePage = false;
            }
          };
          if(data.result && data.result.datas && data.result.datas.length>0){
            
            
            $scope[item].datas = $scope[item].datas.concat(data.result.datas);
            
            $scope[item].count = data.result.count;
            
            
            $scope[item].totalPage = data.result.totalPage;
            if (data.result.totalPage > data.result.pageNo) {
              $scope.nextPage = true;
            }else {
              $scope.nextPage = false;
            }
            
            
            totalPage = data.result.totalPage;
            
          }else{
            $scope.noQuestion = true;
          };
          if (typeof cb === "function") cb(data);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function (err) {
          if (typeof cb === "function") cb(err);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    }
    
    
    addDatas ();
    
    
    
    $scope.addMoreList = function (e) {
      if(page <= totalPage){
        addDatas ();
      }else {
        //alert('没有更多了，休息一会儿');
        //angular.element(e).addClass("hide");
        $scope.nextPage = false;
      }
    };
  };
  
}])
.directive('loadMoreData', [ 'loadMore', function (loadMore) {
  return {
    replace: true,
//    template:'<span><a class="btn btn-block add-more"  ng-if="nextPage"  ng-click="addMoreList($event)">加载更多</a></span>',
    template:'<ion-infinite-scroll ng-if="nextPage" icon="ion-loading-c" on-infinite="addMoreList($event)"></ion-infinite-scroll>',
    link: function($scope, elem, attrs) {
      
      var params = {
        path: '/'+attrs.path  
      };
      if (attrs.loadMoreData != '') {
        params['state'] = attrs.loadMoreData;
      }
      if(attrs.sate) {
        params.state = attrs.sate;
      }
      if(attrs.params) {
        params = angular.extend(params, JSON.parse(attrs.params));
      }
      loadMore($scope,attrs.recall,params);
    }
  };
}])
.directive('focusMe',['$timeout', function($timeout) {
   return {
        link: function(scope, element, attrs) {
//            $timeout(function() {
//                element[0].focus();
//            },200);
//            var keyboardHeight,
//              clientHeight = element[0].clientHeight;
//            window.addEventListener('native.keyboardshow', keyboardShowHandler);
//            function keyboardShowHandler(e){
//              keyboardHeight =  e.keyboardHeight;
//              if (element[0].nodeName == 'TEXTAREA' && element.hasClass('full-screen-textarea')) {
//                scope.pageHeightStyle = {
//                        height:clientHeight - keyboardHeight+ 'px'
//                    }
//                
//              }
//            }
//            element.on('focus', function (e) {
//              
//              
//            });
//            
//            element.on('blur', function () {
//              if (element[0].nodeName == 'TEXTAREA' && element.hasClass('full-screen-textarea')) {
//                element.css({
//                    height:'100%'
//                  });
//              }
//            });
            
        }
    };
}])
// .directive('KeyboardClose',['$timeout', function($timeout) {
//   return {
//     link: function(scope, element, attrs) {
//       $timeout(function() {
//         //element[0].focus();
//         cordova.plugins.Keyboard.close()
//       },200);
//     }
//   };
// }])
.directive('galleryZoomview', ['$ionicSlideBoxDelegate', '$ionicScrollDelegate', '$timeout', '$parse', '$ionicModal',
                                function ($ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $parse, $ionicModal) {
  return {
    scope: true,
    link: function ($scope, element, attrs, controllers) {
      //图片预览
      
      element.on('click', function () {
        $scope.slideIndex = attrs.galleryZoomview;
        $scope.activeSlide = Number($scope.slideIndex);
        $scope.galleryImages = JSON.parse(attrs.galleryImages);
        $scope.showModal ('templates/gallery-zoomview.html');
      });
      
      
      $scope.zoomMin = 1;
      
      $scope.showModal = function (templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope
        }).then(function (modal) {
          $scope.imageZoomModal = modal;
          $scope.imageZoomModal.show();
        });
      };
      
      $scope.closeImageZoomModal = function () {
        $scope.imageZoomModal.hide();
        $scope.imageZoomModal.remove();
      };
      
      $scope.rotateDeg = 0;
      $scope.galleryImageTransform = {};
      $scope.galleryImageTransformLeft = function (i) {
        $scope.rotateDeg -= 90;
        if ($scope.rotateDeg === -360) {
          $scope.rotateDeg = 0;
        }
        
        $scope.galleryImageTransform[i] = "galleryImageTransform"+$scope.rotateDeg;
      };
      $scope.galleryImageTransformRight = function (i) {
        $scope.rotateDeg += 90;
        if ($scope.rotateDeg === 360) {
          $scope.rotateDeg = 0;
        }
        
        $scope.galleryImageTransform[i] = "galleryImageTransform"+$scope.rotateDeg;
      };
      
      
      $scope.updateSlideStatus = function (slide) {
        $scope.$on('$ionicView.loaded', function(){
          $timeout(function () {
            var zoomFactor = $ionicScrollDelegate.$getByHandle('scroll' + slide).getScrollPosition().zoom;
            if (zoomFactor == $scope.zoomMin) {
              $ionicSlideBoxDelegate.enableSlide(true);
            }else {
              $ionicSlideBoxDelegate.enableSlide(false);
            };
          });
        });
        
      }; 
    }
  };
}])
.directive('phoneSms', ['$timeout', '$parse', '$rootScope', 'showCode', '$http', 'defConfig', 'errorInfo', '$interval', '$ionicPopup',
               function ($timeout, $parse, $rootScope, showCode, $http, defConfig, errorInfo, $interval, $ionicPopup) {
  return  {
    template: '<button class="button button-small button-energized" ng-if="!resendSmsCode" ng-click="phoneCode($event)">手机验证码</button>'
           +'<button class="button button-stable" disabled="disabled" ng-if="resendSmsCode">{{resendSmsSec}}</button>',
        link: function postLink($scope, element, attrs, controllers) {
          
          $scope.smsItems = {};
          
          var s = 0;
          function sendSms () {
            $scope.smsItems.phone = attrs.ingPhone || '';
            if (attrs.sendParams) {
              $scope.smsItems = JSON.parse(attrs.sendParams);
            }
            if($scope.smsItems.phone){
              $http.post(defConfig.url+defConfig.path + '/' + attrs.sendPath,$scope.smsItems)
              .success(function (data){
                errorInfo.errMsg(data);
                if(!data.error) {
                  reShowSms ();
                  $scope.isShowCode = false;
                  s = 0;
                }else {
                }
              });
            }else{
              $ionicPopup.alert({
            title: '错误!',
            template: '请填写手机号！',
            okText: '确定'
          }).then(function () {
            //$location.path('/question/account/main');
          });
            };
          };
          
          function  reShowSms () {
            $scope.resendSmsCode = true;
            var timeDate = 60;
            $scope.resendSmsSec = timeDate + '秒后获取';
            var promise = $interval(function(){
              timeDate --;
              $scope.resendSmsSec = timeDate + '秒后获取';
              if(timeDate == 0) {
                return cancelPrime();
              }
            },1000);
            function cancelPrime () {
              $scope.resendSmsCode = false;
              $interval.cancel(promise);
            }
            
          };
          
          $scope.phoneCode = function () {
            
            if( s === 1 ){
              sendSms ();
            }else{
              showCode('isShowCodeBySms',$scope)
              .then(function (data) {
                s = 1;
                $ionicPopup.alert({
                title: '错误!',
                template: '发送次数过多，请填写图片验证码！',
                okText: '确定'
              }).then(function () {
                //$location.path('/question/account/main');
              });
              },function(data){
                sendSms ();
              });
            }
          };
        }
  };
}])
.directive('assessLists',['loadMore', 'replyAssessFac', function (loadMore, replyAssessFac) {
  return {
    templateUrl: 'templates/assessLists.html',
    link: function ($scope, $element, $attrs) {
      
      $scope.aid = $attrs.aid
      
      $scope.sortFieldParams = {
          path:'/ansAssess',
          ansId: $attrs.aid
        };
      var pageSize = $attrs.pagesize;
      if (pageSize) {
        $scope.sortFieldParams.pageSize = pageSize;
      }
      if ($attrs.nomore) {
        $scope.nomoreLink = true;
      };
      loadMore($scope,'ansAssess',$scope.sortFieldParams, function (data) {
        if (!!data.result.datas.length) {
          $scope.$parent.$parent.$parent.isAssess = true;
          $scope.ansAssess.totalCount = data.result.totalCount;
          $scope.ansAssess.averageScore = data.result.averageScore;
        }
      });
      
      replyAssessFac ($scope)
      
    }
  };
}])
.directive('browseTo',['$ionicGesture', function ($ionicGesture) {
 return {
  restrict: 'A',
  link: function ($scope, $element, $attrs) {
   var handleTap = function (e) {
    // todo: capture Google Analytics here
     var inAppBrowser;
     if (window.cordova) {
       inAppBrowser = window.open(encodeURI($attrs.browseTo), $attrs.target); //'_system'
     }else {
       window.location.href = encodeURI($attrs.browseTo);
     }
   };
   var tapGesture = $ionicGesture.on('tap', handleTap, $element);
   $scope.$on('$destroy', function () {
    // Clean up - unbind drag gesture handler
    $ionicGesture.off(tapGesture, 'tap', handleTap);
   });
  }
 };
}])
.directive('windowOpen',['$ionicGesture', function ($ionicGesture) {
 return {
  restrict: 'A',
  link: function ($scope, $element, $attrs) {
   var handleTap = function (e) {
    // todo: capture Google Analytics here
     var inAppBrowser;
     if (window.cordova) {
       inAppBrowser = window.open(encodeURI($attrs.windowOpen), $attrs.target); //'_system'
     }else {
       window.open(encodeURI($attrs.windowOpen), $attrs.target);
     }
   };
   var tapGesture = $ionicGesture.on('tap', handleTap, $element);
   $scope.$on('$destroy', function () {
    // Clean up - unbind drag gesture handler
    $ionicGesture.off(tapGesture, 'tap', handleTap);
   });
  }
 };
}])
// 输入框验证
  .directive('textMaxLength', ['$compile', function($compile) {
    return {
      require: 'ngModel',
      link: function(scope, element, attrs, ngModel) {
        var template = '';
        var overLen = attrs.maxLength;
        var maxSize = attrs.maxLength;
        var tipsType = attrs.textMaxLength;
        var texTend = attrs.textEnd;
        var minSize = attrs.min;
        var len = 0;
        var templateDef = '最多输入<b>' + maxSize + '</b>个字，还可以输入';
        template = templateDef + '<b>' + overLen + '</b>个字';
        if (tipsType =="mini") {
        	template = '<b>' + overLen + ' </b>'
        }
        element.next('.count-num').html(template);
        scope.$watch(attrs.ngModel, function(newValue, oldValue) {
	    	if (!newValue) {
	    		return;
	    	}
          newValue = newValue + '';
          oldValue = oldValue + '';
          len = 0;
          if (newValue) {
            for (var i = 0; i < newValue.length; i++) {
              if (newValue.charCodeAt(i) > 127 || newValue.charCodeAt(i) == 94) {
                len += 1;
              } else {
                len += 0.5;
              }
            }
          }

          overLen = Number(maxSize) - Number(len);
          overLen = overLen.toFixed(0);
          if (overLen < 0) {
            overLen = 0;
          }
          template = templateDef + '<b>' + overLen + '</b>个字';
          if (tipsType =="mini") {
          	template = '<b>' + overLen + ' </b>'
          }
          element.next('.count-num').html(template);
          
          if (len <= maxSize) {
            return;
          } else {
            if (newValue != oldValue) {
              if (len >= maxSize && texTend) {
            	  
           	    ngModel.$setViewValue(oldValue);
                ngModel.$render();
                
              }
            }
          }
        });



      }
    };
  }])
  .directive('myTouchstart', [function() {
      return function(scope, element, attr) {

          element.on('touchstart', function(event) {
              scope.$apply(function() { 
                  scope.$eval(attr.myTouchstart); 
              });
          });
      };
  }])
  .directive('myTouchend', [function() {
      return function(scope, element, attr) {

          element.on('touchend', function(event) {
              scope.$apply(function() { 
                  scope.$eval(attr.myTouchend); 
              });
          });
      };
  }])
// 语音
  .directive('recordAudio', ['$compile', '$cordovaCapture', '$cordovaMedia', 'defConfig', '$cordovaFileTransfer', '$http', 
                             function($compile, $cordovaCapture, $cordovaMedia, defConfig, $cordovaFileTransfer, $http) {
    return {
      require: 'ngModel',
      scope: {},
//      replace: true,
      template:'<button ng-click="creatAudio()" ng-if="!sound.file && !isWx && isApp" class="button icon-left ion-mic-a button-calm">{{buttonText}} 最长60秒</button>'+
      '<button my-touchstart="touchStart()" my-touchend="touchEnd()" ng-class="wxtouchStyle" ng-if="!wxAudiolocalId && isWx" class="button icon-left ion-mic-a">{{wxbuttonText}}</button>'+
        '<button ng-if="sound && sound.file && !isWx  && isApp" ng-click="play()"  class="button icon-left ion-volume-high button-calm">试听语音</button>'+
    	  '<button ng-if="wxAudiolocalId && isWx" ng-click="wxPlayAudio()"  class="button icon-left ion-volume-high button-calm">试听语音</button>'+
    	  '<button ng-if="wxAudiolocalId && isWx" ng-click="del()"   class="button icon-left ion-trash-a button-calm button-clear"></button>'+
    	  '<button ng-if="sound && sound.file  && isApp" ng-click="del()"  class="button icon-left ion-trash-a button-calm button-clear"></button><ion-spinner ng-if="uploading" icon="ios" style="position: relative; top: 2px; left: 4px"></ion-spinner>',
      link: function($scope, element, attrs, ngModel) {
       
    	  $scope.isWx = false;
    	  var ua = navigator.userAgent.toLowerCase();

        if(ua.match(/MicroMessenger/i)=="micromessenger") {
          $scope.isWx = true;
        };
        
        $scope.isIOS = ionic.Platform.isIOS();
	    $scope.isAndroid = ionic.Platform.isAndroid();
	    ionic.Platform.ready(function () {
			$scope.url = defConfig.url + attrs.src;
			if($scope.isIOS || $scope.isAndroid){
				$scope.isApp = true;
			}
			
		});
        
        $scope.wxtouchStyle = "button-calm";
        $scope.wxbuttonText = "按住 说话";
        
        $scope.touchStart = function () {
        	$scope.wxbuttonText = "松开 结束";
        	$scope.wxtouchStyle = "button-balanced";
          wx.startRecord();
          wx.onVoiceRecordEnd({
              // 录音时间超过一分钟没有停止的时候会执行 complete 回调
              complete: function (res) {
                  $scope.wxAudiolocalId = res.localId; 
                  $scope.wxUploadVoice (res.localId);
                  $scope.wxbuttonText = "按住 说话";
                  $scope.wxtouchStyle = "button-calm";
              }
          });
        }
    	  
    	  $scope.touchEnd = function () {
          wx.stopRecord({
              success: function (res) {
                  $scope.wxAudiolocalId  = res.localId;
                  $scope.wxUploadVoice (res.localId);
                  $scope.wxbuttonText = "按住 说话";
                  $scope.wxtouchStyle = "button-calm";
              }
          });
        }

        $scope.wxUploadVoice = function (id) {
          wx.uploadVoice({
              localId: id, // 需要上传的音频的本地ID，由stopRecord接口获得
              isShowProgressTips: 1, // 默认为1，显示进度提示
                  success: function (res) {
                  var serverId = res.serverId; // 返回音频的服务器端ID
                  
                  $http.post(defConfig.url + defConfig.path + '/auth/uploadAudio', {
                	  audioWxId: res.serverId
                  })
                  .success(function (data){
                    if(data) {
//                    	var result = JSON.parse(result);
                    	ngModel.$setViewValue(data.result.no);
                        ngModel.$render();
                    }else {
                    }
                  });
                  
              }
          });

        }
    	  
        $scope.wxPlayAudio = function () {
          wx.playVoice({
              localId: $scope.wxAudiolocalId  // 需要播放的音频的本地ID，由stopRecord接口获得
          });
          wx.onVoicePlayEnd({
              success: function (res) {
                  $scope.wxAudiolocalId = res.localId; // 返回音频的本地ID
              }
          });
        }


    	  $scope.audioFiles = function (audioFile, cb) {
        	  
        	  
              
              
        	  var server =  defConfig.url + defConfig.path + '/auth/uploadAudio',
//        	  audioFile = $scope.questionItme.audios[0],
        	  filePath = audioFile.localURL;
//        	  options = $scope.questionItme;
        	  var options = {
        		        fileKey: "audios",
        		        fileName: audioFile.name,
        		        chunkedMode: false,
        		        mimeType: "audio/*",
        		        httpMethod: "post"
        		    };
        	  
//        	  console.log(filePath,$scope.questionItme.audios)
        	  $cordovaFileTransfer.upload(encodeURI(server), filePath, options)
              .then(function(data) {
                // Success!
            	  if (typeof cb === "function") {
            		  cb(JSON.parse(data.response).result.no);
            	  }
              }, function(err) {
            	  if (typeof cb === "function") {
            		  cb(err);
            	  }
                // Error
//            	  console.log(err)
              }, function (progress) {
//            	  console.log(progress)
                // constant progress updates
              });
          }
    	  
    	  
    	  
    	  
//    	  ngModel.$setViewValue();
//    	  ngModel.$render();
    	  $scope.buttonText = attrs.recordAudio;
    	  
    	  $scope.sound = {};
          $scope.isPlaying = false;
          $scope.uploading = false;
          //语音提问
          $scope.creatAudio = function () {
        	  var options = { limit: 3, duration: 60 };

        	    $cordovaCapture.captureAudio(options).then(function(audioData) {
        	      // Success! Audio data is here
//        	    	console.log(audioData)
        	    	$scope.uploading = true;
        	    	$scope.sound.file = audioData[0].localURL;
        			$scope.sound.filePath = audioData[0].fullPath;
        	    	$scope.audioFiles(audioData[0], function (id) {
        	    		$scope.uploading = false;
        	    		ngModel.$setViewValue(id);
            	    	ngModel.$render();
        	    	});
//        			ngModel.$setViewValue(audioData);
//        	    	ngModel.$render();
        	    }, function(err) {
        	    	// console.log(err)
        	      // An error occurred. Show a message to the user
        	    });
          }
          $scope.del = function () {
        	  $scope.sound.file = null;
        	  $scope.wxAudiolocalId = null;
        	  ngModel.$setViewValue("");
        	  ngModel.$render();
          }
      	$scope.play = function() {
    		
//    		var src = "/src/audio.mp3";
    		var media = $cordovaMedia.newMedia($scope.sound.file);
    		$scope.duration = media.getDuration();
    		var iOSPlayOptions = {
    			    numberOfLoops: 2,
    			    playAudioWhenScreenIsLocked : false
    			  }

    		if (ionic.Platform.isIOS()) {
    			media.play(iOSPlayOptions)
    			$scope.isPlaying = true;
    		}
    		if (ionic.Platform.isAndroid()) {
    			media.play();
    			$scope.isPlaying = true;
    		}
    		$scope.getCurrentPosition = function () {
    			media.getCurrentPosition(function (position) {
        			if (position > -1) {
                        // console.log((position) + " sec");
                    }
        		},function () {
        			
        		})
    		}
    		
    		
    		$scope.stop = function () {
    			media.stop();
    			$scope.isPlaying = false;
    		}
    		
    	}


      }
    };
  }])
.directive('audioPlay',['defConfig', '$ionicPlatform', 'MediaSrv', '$$cordovaMedia', '$timeout', function (defConfig, $ionicPlatform, MediaSrv, $$cordovaMedia, $timeout) {
	return {
		scope: {},
//		template:'<button ng-if="isApp && !isPlaying" ng-click="play()"  class="button button-small icon-left ion-volume-high button-calm">播放语音 {{duration}}</button>'
//			+'<button ng-if="isApp && isPlaying" ng-click="stop()"  class="button button-small icon-left ion-stop button-calm">停止 {{duration}}</button>',
		template: '<ion-audio-track track="myTrack" ng-if="isApp && !isWx" toggle-playback="togglePlayback">'
//	      +'<div class="card">'
//	          +'<div class="item">'
	              +'<ion-audio-controls>'
//	                  +'<a class="button button-block button-icon icon" ion-audio-play>播放语音</a>'
	              +'<button class="button audio-button button-small  button-calm icon-left" ion-audio-play text-play=" 播放语音 " text-pause=" 暂停播放 "></button>'
	                  +'<ion-spinner icon="ios" style="position: relative; top: 2px; left: 4px"></ion-spinner>'
	              +'</ion-audio-controls>'
//	          +'</div>'
//	          +'<div class="item item-divider">'
//	              +'<ion-audio-progress-bar track="myTrack" display-time></ion-audio-progress-bar>'
//	          +'</div>'
//	      +'</div>'
	+'</ion-audio-track>'
	+'<p><audio controls ng-if="isWx">'
		+'<source src="{{url}}" type="audio/wav">'
		+'<source src="{{url}}" type="audio/mpeg">'
	 +'</audio></p>'
	+'<a ng-if="!isApp" class="button audio-button button-small  button-calm icon-left" ng-href="{{html5Path}}/question/downloadApp">收听语音请下载APP</a>',
		link: function($scope, element, attrs, ngModel) {
			 $scope.isWx = false;
	    	  var ua = navigator.userAgent.toLowerCase();

	        if(ua.match(/MicroMessenger/i)=="micromessenger") {
	          $scope.isWx = true;
	        };
	        
			$scope.isIOS = ionic.Platform.isIOS();
		    $scope.isAndroid = ionic.Platform.isAndroid();
		    ionic.Platform.ready(function () {
				$scope.url = defConfig.url + attrs.src.replace(".amr",".wav");
				if($scope.isIOS || $scope.isAndroid){
					$scope.isApp = true;
				}
				$scope.myTrack = {
					    url: $scope.url
					}
				
			});
			
		}
	}
	
//	<audio controls ng-if="questionItems.audios.length">
//	  <source src="{{questionItems.audios[0].filePath}}" type="audio/wav">
//	 <!--  <source src="horse.mp3" type="audio/mpeg"> -->
//	</audio>
	
}])

.directive('ionActionCustomSheet', ['$document', function($document) {
  return {
    restrict: 'E',
    scope: true,
    replace: true,
    link: function($scope, $element) {

      var keyUp = function(e) {
        if (e.which == 27) {
          $scope.cancel();
          $scope.$apply();
        }
      };

      var backdropClick = function(e) {
        if (e.target == $element[0]) {
          $scope.cancel();
          $scope.$apply();
        }
      };
      $scope.$on('$destroy', function() {
        $element.remove();
        $document.unbind('keyup', keyUp);
      });

      $document.bind('keyup', keyUp);
      $element.bind('click', backdropClick);
    },
    template: '<div class="action-sheet-backdrop">' +
                '<div class="action-sheet-wrapper">' +
                  '<div class="action-sheet" ng-class="{\'action-sheet-has-icons\': $actionSheetHasIcon}">' +
                  	'<div class="action-sheet-group custom-desc-sheet" ng-if="customDescSheet" ng-style="customStyle">' +
	                  '<div class="action-sheet-title" ng-bind-html="customDescSheet"></div>' +
	                '</div>' +
                    '<div class="action-sheet-group action-sheet-inline action-sheet-options">' +
                      '<div class="action-sheet-title" ng-if="titleText" ng-bind-html="titleText"></div>' +
                      '<button class="button action-sheet-option" ng-style="{width:(100/buttons.length+\'%\')}" ng-click="buttonClicked($index)" ng-repeat="b in buttons" ng-bind-html="b.text" ng-class="b.class"></button>' +
                    '</div>' +
                    '<div class="action-sheet-group action-sheet-options">' +
                      '<button class="button action-sheet-option" ng-click="buttonGroupClicked($index)" ng-repeat="b in buttonsGroup" ng-bind-html="b.text" ng-class="b.class"></button>' +
                      '<button class="button destructive action-sheet-destructive" ng-if="destructiveText" ng-click="destructiveButtonClicked()" ng-bind-html="destructiveText"></button>' +
                  '</div>' +
                    '<div class="action-sheet-group action-sheet-cancel" ng-if="cancelText">' +
                      '<button class="button" ng-click="cancel()" ng-bind-html="cancelText"></button>' +
                    '</div>' +
                  '</div>' +
                '</div>' +
              '</div>'
  };
}])
// for media plugin : http://plugins.cordova.io/#/package/org.apache.cordova.media
.factory('MediaSrv',['$q', '$ionicPlatform', '$window', function($q, $ionicPlatform, $window){
  var service = {
    loadMedia: loadMedia,
    getStatusMessage: getStatusMessage,
    getErrorMessage: getErrorMessage
  };

  function loadMedia(src, onError, onStatus, onStop){
    var defer = $q.defer();
    $ionicPlatform.ready(function(){
      var mediaSuccess = function(){
        if(onStop){onStop();}
      };
      var mediaError = function(err){
        _logError(src, err);
        if(onError){onError(err);}
      };
      var mediaStatus = function(status){
        if(onStatus){onStatus(status);}
      };

      if($ionicPlatform.is('android')){src = '/android_asset/www/' + src;}
      defer.resolve(new $window.Media(src, mediaSuccess, mediaError, mediaStatus));
    });
    return defer.promise;
  }

  function _logError(src, err){
    console.error('media error', {
      code: err.code,
      message: getErrorMessage(err.code)
    });
  }

  function getStatusMessage(status){
    if(status === 0){return 'Media.MEDIA_NONE';}
    else if(status === 1){return 'Media.MEDIA_STARTING';}
    else if(status === 2){return 'Media.MEDIA_RUNNING';}
    else if(status === 3){return 'Media.MEDIA_PAUSED';}
    else if(status === 4){return 'Media.MEDIA_STOPPED';}
    else {return 'Unknown status <'+status+'>';}
  }

  function getErrorMessage(code){
    if(code === 1){return 'MediaError.MEDIA_ERR_ABORTED';}
    else if(code === 2){return 'MediaError.MEDIA_ERR_NETWORK';}
    else if(code === 3){return 'MediaError.MEDIA_ERR_DECODE';}
    else if(code === 4){return 'MediaError.MEDIA_ERR_NONE_SUPPORTED';}
    else {return 'Unknown code <'+code+'>';}
  }

  return service;
  
  
  
  window.Media = function(src, mediaSuccess, mediaError, mediaStatus){
//	   src: A URI containing the audio content. (DOMString)
//	   mediaSuccess: (Optional) The callback that executes after a Media object has completed the current play, record, or stop action. (Function)
//	   mediaError: (Optional) The callback that executes if an error occurs. (Function)
//	   mediaStatus: (Optional) The callback that executes to indicate status changes. (Function)

	  if (typeof Audio !== "function" && typeof Audio !== "object") {
//	    console.warn("HTML5 Audio is not supported in this browser");
	  }
	  var sound = new Audio();
	  sound.src = src;
	  sound.addEventListener("ended", mediaSuccess, false);
	  sound.load();

	  return {
	    // Returns the current position within an audio file (in seconds).
	    getCurrentPosition: function(mediaSuccess, mediaError){ 
	    	mediaSuccess(sound.currentTime); 
	    },
	    // Returns the duration of an audio file (in seconds) or -1.
	    getDuration: function(){ 
	    	return isNaN(sound.duration) ? -1 : sound.duration; 
	    },
	    // Start or resume playing an audio file.
	    play: function(){ sound.play(); },
	    // Pause playback of an audio file.
	    pause: function(){ sound.pause(); },
	    // Releases the underlying operating system's audio resources. Should be called on a ressource when it's no longer needed !
	    release: function(){},
	    // Moves the position within the audio file.
	    seekTo: function(milliseconds){}, // TODO
	    // Set the volume for audio playback (between 0.0 and 1.0).
	    setVolume: function(volume){ sound.volume = volume; },
	    // Start recording an audio file.
	    startRecord: function(){},
	    // Stop recording an audio file.
	    stopRecord: function(){},
	    // Stop playing an audio file.
	    stop: function(){ sound.pause(); if(mediaSuccess){mediaSuccess();} } // TODO
	  };
	};
  
}])
.factory('$$cordovaMedia', ['$q', function ($q) {

    return {
      newMedia: function (src,success,error,mediaStatus) { 
        var media = new Media(src,success,error,mediaStatus);
        return media;
      },

      getCurrentPosition: function (source) {
        var q = $q.defer();

        source.getCurrentPosition(function (success) {
          q.resolve(success);

        }, function (error) {
          q.reject(error);
        });

        return q.promise;
      },

      getDuration: function (source) {

        return source.getDuration();
      },

      play: function (source) {
        source.play();

        // iOS quirks :
        // -  myMedia.play({ numberOfLoops: 2 }) -> looping
        // -  myMedia.play({ playAudioWhenScreenIsLocked : false })
      },

      pause: function (source) {
        return source.pause();
      },

      release: function (source) {
        return source.release();
      },


      seekTo: function (source, milliseconds) {

        return source.seekTo(milliseconds);
      },

      setVolume: function (source, volume) {
        return source.setVolume(volume);
      },

      startRecord: function (source) {
        return source.startRecord();
      },

      stopRecord: function (source) {

        return source.stopRecord();
      },

      stop: function (source) {
        return source.stop();
      }
    };
}])
;

angular.module('ionic-audio', ['ionic']);

angular.module('ionic-audio').filter('time', function () {
	var addLeadingZero = function(n) {
        return (new Array(2).join('0')+n).slice(-2)
    };

    return function(input) {
        input = input || 0;
        var t = parseInt(input);
        return addLeadingZero(Math.floor(t / 60)) + ':' + addLeadingZero(t % 60);
    };
});


angular.module('ionic-audio').filter('duration', ['$filter', function ($filter) {
    return function (input) {
        return (input > 0) ? $filter('time')(input) : '';
    };
}]);


angular.module('ionic-audio').factory('MediaManager', ['$interval', '$timeout', '$window', function ($interval, $timeout, $window) {
    var tracks = [], currentTrack, currentMedia, playerTimer;

    if (!$window.cordova && !$window.Media) {
//        console.log("ionic-audio: missing Cordova Media plugin. Have you installed the plugin? \nRun 'ionic plugin add cordova-plugin-media'");
        return null;
    }

    return {
        add: add,
        play: play,
        pause: pause,
        stop: stop,
        seekTo: seekTo,
        destroy: destroy
    };

    function find(track) {
        if (track.id < 0) return;

        var replaceTrack = tracks.filter(function(localTrack) {
            return localTrack.id == track.id;
        }).pop();

        if (replaceTrack) {
            tracks.splice(replaceTrack.id, 1, track);
        }
        return replaceTrack;
     }

    /*
    Creates a new Media from a track object
     var track = {
         url: 'https://s3.amazonaws.com/ionic-audio/Message+in+a+bottle.mp3',
         artist: 'The Police',
         title: 'Message in a bottle',
         art: 'img/The_Police_Greatest_Hits.jpg'
     }
     */
    function add(track, playbackSuccess, playbackError, statusChange, progressChange) {
        if (!track.url) {
//            console.log('ionic-audio: missing track url');
            return;
        }

        angular.extend(track, {
            onSuccess: playbackSuccess,
            onError: playbackError,
            onStatusChange: statusChange,
            onProgress: progressChange,
            status: 0,
            duration: -1,
            progress: 0
        });

        if (find(track)) {
            return track.id;
        }

        track.id  = tracks.push(track) - 1;
        return track.id;
    }

    function play(trackID) {
        if (!angular.isNumber(trackID) || trackID > tracks.length - 1) return;

        // avoid two tracks playing simultaneously
        if (currentTrack) {
            if (currentTrack.id == trackID) {
                if (currentTrack.status == Media.MEDIA_RUNNING) {
                    pause();
                } else {
                    //if (currentTrack.status == Media.MEDIA_PAUSED) {
                        resume();
                    //}
                }
                return;
            } else {
                if (currentTrack.id > -1) {
                    stop();
                }
            }
        }

        $timeout(function() {
            playTrack(tracks[trackID]);
        }, 300);
    }

    function pause() {
//        console.log('ionic-audio: pausing track '  + currentTrack.title);

        currentMedia.pause();
        stopTimer();
    }

    function seekTo(pos) {
        if (!currentMedia) return;

        currentMedia.seekTo(pos * 1000);
    }

    function destroy() {
        stopTimer();
        releaseMedia();
    }


    function playTrack(track) {
        currentTrack = track;

//        console.log('ionic-audio: playing track ' + currentTrack.title);

        currentMedia = createMedia(currentTrack);
        currentMedia.play();

        startTimer();
    }

    function resume() {
//        console.log('ionic-audio: resuming track ' + currentTrack.title);
        currentMedia.play();
        startTimer();
    }

    function stop() {
        if (currentMedia){
//            console.log('ionic-audio: stopping track ' + currentTrack.title);
            currentMedia.stop();    // will call onSuccess...
        }
    }

    function createMedia(track) {
        if (!track.url) {
//            console.log('ionic-audio: missing track url');
            return undefined;
        }

        return new Media(track.url,
            angular.bind(track, onSuccess),
            angular.bind(track, onError),
            angular.bind(track, onStatusChange));
    }

    function releaseMedia() {
        if (angular.isDefined(currentMedia)) {
            currentMedia.release();
            currentMedia = undefined;
            currentTrack = undefined;
        }
    }

    function onSuccess() {
        stopTimer();
        releaseMedia();

        if (angular.isFunction(this.onSuccess))
            this.onSuccess();
    }

    function onError() {
        if (angular.isFunction(this.onError))
            this.onError();
    }

    function onStatusChange(status) {
        this.status = status;

        if (angular.isFunction(this.onStatusChange))
            this.onStatusChange(status);
    }

    function stopTimer() {
        if (angular.isDefined(playerTimer)) {
            $interval.cancel(playerTimer);
            playerTimer = undefined;
        }
    }

    function startTimer() {
        if ( angular.isDefined(playerTimer) ) return;

        if (!currentTrack) return;

        playerTimer = $interval(function() {
            if ( currentTrack.duration < 0){
                currentTrack.duration = currentMedia.getDuration();
            }

            currentMedia.getCurrentPosition(
                // success callback
                function(position) {
                    if (position > -1) {
                        currentTrack.progress = position;
                    }
                },
                // error callback
                function(e) {
//                    console.log("Error getting pos=" + e);
                });

            if (angular.isFunction(currentTrack.onProgress))
                currentTrack.onProgress(currentTrack.progress, currentTrack.duration);

        }, 1000);
    }
}]);
angular.module('ionic-audio').directive('ionAudioTrack', ['MediaManager', '$rootScope', ionAudioTrack]);

function ionAudioTrack(MediaManager, $rootScope) {
    return {
        transclude: true,
        template: '<ng-transclude></ng-transclude>',
        restrict: 'E',
        scope: {
            track: '=',
            togglePlayback: '='
        },
        require: 'ionAudioTrack',
        link: link,
        controller: ['$scope', '$element', ionAudioTrackCtrl]
    };

    function link(scope, element, attr, controller) {
        controller.hasOwnProgressBar = element.find('ion-audio-progress-bar').length > 0
    }

    function ionAudioTrackCtrl($scope, $element) {
        var controller = this;

        var init = function(newTrack, oldTrack) {
            if (!newTrack || !newTrack.url) return;

            newTrack.progress = 0;
            newTrack.status = 0;
            newTrack.duration = -1;
            if (oldTrack && oldTrack.id !== undefined) newTrack.id = oldTrack.id; 

            if (MediaManager) {
                MediaManager.add(newTrack, playbackSuccess, null, statusChange, progressChange);
            }
        };

        var playbackSuccess = function() {
            $scope.track.status = 0;
            $scope.track.progress = 0;
        };
        var statusChange = function(status) {
            $scope.track.status = status;
        };
        var progressChange = function(progress, duration) {
            $scope.track.progress = progress;
            $scope.track.duration = duration;
        };
        var notifyProgressBar = function() {
            $rootScope.$broadcast('ionic-audio:trackChange', $scope.track);
        };

        this.seekTo = function(pos) {
            MediaManager.seekTo(pos);
        };

        this.getTrack = function() {
            return $scope.track;
        };

        this.start = function() {
            if (!$scope.track || !$scope.track.url) return;

            MediaManager.play($scope.track.id);

            // notify global progress bar if detached from track
            if (!controller.hasOwnProgressBar) notifyProgressBar();

            return $scope.track.id;
        };

        var unbindWatcher = $scope.$watch('track', function(newTrack, oldTrack) {  
            if (newTrack === undefined) return;         
            MediaManager.stop();
            init(newTrack, oldTrack);
        });

        $scope.$on('$destroy', function() {
            unbindWatcher();
            MediaManager.destroy();
        });
    }
}
angular.module('ionic-audio').directive('ionAudioProgress', ionAudioProgress);

function ionAudioProgress() {
    return {
        restrict: 'E',
        scope: {
            track: '='
        },
        template: '{{track.progress | time}}'
    }
}

angular.module('ionic-audio').directive('ionAudioProgressBar', ['MediaManager', ionAudioProgressBar]);

function ionAudioProgressBar(MediaManager) {
    return {
        restrict: 'E',
        scope: {
            track: '='
        },
        template:
//            '<h2 class="ion-audio-track-info" ng-style="displayTrackInfo()">{{track.title}} - {{track.artist}}</h2>' +
//            '<div class="range">' +
//            '<ion-audio-progress track="track"></ion-audio-progress>' +
//            '<input type="range" name="volume" min="0" max="{{track.duration}}" ng-model="track.progress" on-release="sliderRelease()" disabled>' +
            '<ion-audio-duration track="track"></ion-audio-duration>',
//            '</div>',
        link: link
    };

    function link(scope, element, attrs) {
        var slider =  element.find('input'), unbindTrackListener;

        function init() {
            scope.track.progress = 0;
            scope.track.status = 0;
            scope.track.duration = -1;
        }

        if (!angular.isDefined(attrs.displayTime)) {
            element.find('ion-audio-progress').remove();
            element.find('ion-audio-duration').remove();
        }
        if (!angular.isDefined(attrs.displayInfo)) {
            element.find('h2').remove();
        }

        if (angular.isUndefined(scope.track)) {
            scope.track = {};

            // listens for track changes elsewhere in the DOM
            unbindTrackListener = scope.$on('ionic-audio:trackChange', function (e, track) {
                scope.track = track;
            });
        }

        // disable slider if track is not playing
        var unbindStatusListener = scope.$watch('track.status', function(status) {
            // disable if track hasn't loaded
            slider.prop('disabled', status == 0);   //   Media.MEDIA_NONE
        });

        // hide/show track info if available
        scope.displayTrackInfo = function() {
            return { visibility: angular.isDefined(attrs.displayInfo) && (scope.track.title || scope.track.artist) ? 'visible' : 'hidden'}
        };

        // handle track seek-to
        scope.sliderRelease = function() {
            var pos = scope.track.progress;
            MediaManager.seekTo(pos);
        };

        scope.$on('$destroy', function() {
            unbindStatusListener();
            if (angular.isDefined(unbindTrackListener)) {
                unbindTrackListener();
            }
        });

        init();
    }
}
angular.module('ionic-audio').directive('ionAudioPlay', ['$ionicGesture', '$timeout', ionAudioPlay]);

function ionAudioPlay($ionicGesture, $timeout) {
    return {
        restrict: 'A',
        require: '^^ionAudioControls',
        link: link
    };

    function link(scope, element, attrs, controller) {
        var isLoading, debounce, currentStatus = 0;

        var init = function() {
            isLoading = false;
            element.addClass('ion-play');
            element.removeClass('ion-pause');
            element.text(attrs.textPlay);
        };

        var setText = function() {
            if (!attrs.textPlay || !attrs.textPause) return;

            element.text((element.text() == attrs.textPlay ? attrs.textPause : attrs.textPlay));
        };

        var togglePlaying = function() {
            element.toggleClass('ion-play ion-pause');
            setText();
        };

        $ionicGesture.on('tap', function() {
            // debounce while loading and multiple clicks
            if (debounce || isLoading) {
                debounce = false;
                return;
            }

            if (currentStatus == 0) isLoading = true;

            controller.play();
            togglePlaying();
        }, element);

        $ionicGesture.on('doubletap', function() {
            debounce = true;
        }, element);

        var unbindStatusListener = scope.$parent.$watch('track.status', function (status) {
            //  Media.MEDIA_NONE or Media.MEDIA_STOPPED
            if (status == 0 || status == 4) {
                init();
            } else if (status == 2) {   // Media.MEDIA_RUNNING
                isLoading = false;
            }

            currentStatus = status;
        });

        var unbindPlaybackListener = scope.$parent.$watch('togglePlayback', function (newPlayback, oldPlayback) {
            if (newPlayback == oldPlayback) return;
            $timeout(function() {
                togglePlaying();
                controller.play();
            },300)
        });

        init();

        scope.$on('$destroy', function() {
            unbindStatusListener();
            unbindPlaybackListener();
        });
    }
}

angular.module('ionic-audio').directive('ionAudioDuration', ionAudioDuration);

function ionAudioDuration() {
    return {
        restrict: 'E',
        scope: {
            track: '='
        },
        template: '{{track.duration | duration}}'
    }
}

angular.module('ionic-audio').directive('ionAudioControls', function() {
    return {
      restrict: 'EA',
      require: ['ionAudioControls', '^^ionAudioTrack'],
      controller: ['$scope', '$element', ionAudioControlsCtrl],
      link: link
    };

function ionAudioControlsCtrl($scope, $element) {
        var spinnerElem = $element.find('ion-spinner'), hasLoaded, self = this;

        spinnerElem.addClass('ng-hide');

        this.toggleSpinner = function() {
          spinnerElem.toggleClass('ng-hide');
        };

        this.play = function() {
          if (!hasLoaded) {
              self.toggleSpinner();
          }
          this.start();
        };

        var unbindStatusListener = $scope.$parent.$watch('track.status', function (status) {
            switch (status) {
              case 1: // Media.MEDIA_STARTING
                  hasLoaded = false;
                  break;
              case 2: // Media.MEDIA_RUNNING
                  if (!hasLoaded) {
                      self.toggleSpinner();
                      hasLoaded = true;
                  }
                  break;
              //case 3: // Media.MEDIA_PAUSED
              //    break;
              case 0: // Media.MEDIA_NONE
              case 4: // Media.MEDIA_STOPPED
                  hasLoaded = false;
                  break;
            }
        });

        $scope.$on('$destroy', function() {
          unbindStatusListener();
        });
    }

    function link(scope, element, attrs, controllers) {
        controllers[0].start = controllers[1].start;
    }
});